//+-----------------------------------------------------------------
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"
#property indicator_chart_window
//-----------------------------------------------------------------
extern int    alertsForNotOlderThan = 300;
extern int    alertsForMagicNumber  =   0;
extern string alertsForSymbol       =  "";
extern bool   alertsOn              = true;
extern bool   alertsSound           = true;
extern bool   alertsMessage         = true;
extern bool   alertsNotification    = false;
extern bool   alertsEmail           = false;

//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

int    tickets[];
bool   alerted[];
string symbols[];
int    types[];
int    times[];
int init()   { return(0); }
int deinit() { return(0); }
int start()
{
   //
   //
   //    colect data for orders
   //
   //

   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS))                                         continue;
      if (alertsForSymbol != "" && alertsForSymbol!=OrderSymbol())               continue;
      if (alertsForMagicNumber != 0 && alertsForMagicNumber!=OrderMagicNumber()) continue;
      if (alertsForNotOlderThan < (TimeCurrent()-OrderOpenTime()))               continue;
      
      //
      //
      //
      //
      //
      
      for (int k=ArraySize(tickets); k>0; k--)
         if (OrderTicket()==tickets[k-1]) break;
         if (k==0) 
         {
            int size = ArraySize(tickets)+1;
               ArrayResize(tickets,size); tickets[size-1] = OrderTicket();
               ArrayResize(alerted,size); alerted[size-1] = false;
               ArrayResize(symbols,size); symbols[size-1] = OrderSymbol();
               ArrayResize(types  ,size); types  [size-1] = OrderType();
               ArrayResize(times  ,size); times  [size-1] = OrderOpenTime();
         }
   }

   //
   //
   //    check if some order needs to be alerted for
   //
   //

   for (i=ArraySize(tickets)-1; i>=0; i--)
   {
      string type = "";
      if (!alerted[i])
      {
         alerted[i] = true;
         switch (types[i])
         {
            case OP_BUY       : type = "buy";        break;
            case OP_SELL      : type = "sell";       break;
            case OP_BUYSTOP   : type = "buy stop";   break;
            case OP_BUYLIMIT  : type = "buy limit";  break;
            case OP_SELLSTOP  : type = "sell stop";  break;
            case OP_SELLLIMIT : type = "sell limit"; break;
         }
         doAlert(type+" opened at : "+TimeToStr(times[i],TIME_DATE|TIME_SECONDS)+" for "+symbols[i]);
      }
   }   
	return(0);
}

//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   string message;
   
   message = doWhat;
       if (alertsMessage)      Alert(message);
       if (alertsEmail)        SendMail(StringConcatenate(Symbol()," order alerts "),message);
       if (alertsNotification) SendNotification("order alerts "+message);
       if (alertsSound)        PlaySound("alert2.wav");
}